	device zxspectrum128
        ORG #6000
begin
 include "TSPor.inc"

x0 equ 32

 ld a,6
 ld bc,SysConfig
 out (c),a

 ld bc,TSConfig
 xor a
 out (c),a

 LD	BC,VConfig
 LD	A,VID_NOGFX
 OUT (C),A

;zero memory
 ld a,$20
clm:
 ld bc,Page3
 out (c),a
 ld hl,$C000,de,$C001,bc,16383,(hl),0:ldir
 inc a
 cp $28:jr nz,clm

 ;open FMAddr access from 0x8000
 ld bc, FMAddr
 ld a, %00010000;0x18
 out (c), a
;load CRAM
 ld de,0
 ld hl,plasm_pal_b
 ld bc,plasm_pal_e-plasm_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
;PalSel = %00 //   0   0
;PalSel          EQU	#07AF
 ld bc,PalSel
 xor a
 out (c),a


 ld  bc,VPage,a,$20:out (c),a

VID_16C         equ $01
VID_256C        equ $02
VID_360X288     equ $C0
VID_NOGFX       equ $20
VID_320X200     equ $40

 LD  BC,VConfig    ;  : %11-360x288, %10-256 
;- LD  A,%01010010;;%01000010
 LD	A,VID_320X200|VID_256C
 OUT (C),A

;----------------------------------------------------
;generate lut for plot
lutpl equ $4000;;bank, MSB addres=2*$100
 ld hl,lutpl
  push hl
  ld de,hl
  inc de
  ld (hl),0
  ld bc,511
  ldir
  pop hl
  ld de,$C020;bank #
lulp1:
 ld (hl),e;bank
 inc h
; ld a,d:sub $C0
 ld (hl),d
 dec h

 inc d,d
 ;ld a,d:or a
 jr nz,nonextbank
 ld d,$c0
 inc e
nonextbank:
 inc l
 ld a,l
 cp 200
 jr nz,lulp1
;fill rest
zm:
 ld (hl),0:inc h
 ld (hl),0:dec h
 inc l:jr nz,zm
;----------------------------------------------------
; jr $
  ld bc,200;ld a,40
lp1:push bc
  call GenP
  pop bc
  dec bc
  ld a,b:or c
  jr nz,lp1

lp:; ei:halt
 ld hl,colr+1:inc (hl)
 call GenP
 call GenE
 
 ld bc,20
wa:djnz wa
 dec c:jr nz,wa
 jr lp

; pop de;D=Y.X
; ld e,iyl
; ld h,lutpl/256
; ld l,a;Y and bank
; ld a,(hl)
;; or a:jr z,nextp
; inc h
; LD	BC,Page3
; OUT (C),A
; ld h,(hl)
;----------------------------------------------------
GenE:
xA:ld hl,22175; xA=(xA+xB)!xB
xB: ld de,63751
 call addxorhlde;;xorhlde
 ld (xA+1),hl

yA:ld hl,17791;;yA=(yA+yB)!yB
yB:ld de,63791
 call addxorhlde;xorhlde
 ld (yA+1),hl

cntE:ld a,period;;cntE=cntE-1
 dec a:jr nz,cntEz;If cntE=0

 ld hl,(xB+1);    xB=(xB+xC)!xC
xCc:ld de,3
; add hl,de
; ld a,h:xor d:ld h,a
; ld a,l:xor e:ld l,a
 call addxorhlde;xorhlde
 ld (xB+1),hl

 ld hl,(yB+1);yB=(yB+yC)!yC
yCc:ld de,3
; add hl,de
; ld a,h:xor d:ld h,a
; ld a,l:xor e:ld l,a
 call addxorhlde;xorhlde
 ld (yB+1),hl

 ld a,period;cntE=period
cntEz:ld (cntE+1),a

 ld a,(xA+1+1):inc a;;x.a=xA+1
; or a:rra
 or a:rra:ld c,a;  x1.a=x>>1; RSH 1
 or a:rra:ld l,a;  x0.a=x1>>1; RSH 1

 ld a,(yA+1+1):inc a;y.a=yA+1
 or a:rra:ld b,a;  y1.a=y>>1; RSH 1
 or a:rra:ld h,a;  y0.a=y1>>1; RSH 1

;  If x0<=y0
 cp l;x0(L)=y0(A or H)
 jr z,doplot1
  ret c; or nc?
doplot1:

;    Plot(127+x0+y0, 127+x1-y1,cc)
 ld a,127:add a,l:add a,h:ld e,a
 ld a,127:add a,c:sub b:ld d,a
 call resplot
;    Plot(127-x0-y0, 127+x1-y1,cc)
 ld a,127:sub l:sub h:ld e,a;E=X
 ld a,127:add a,c:sub b:ld d,a;D=Y
 call resplot
;    Plot(127+x0-y1, 127-x1,cc)
 ld a,127:add a,l:sub b:ld e,a
 ld a,127:sub c:ld d,a;c=x1,l=x0,b=y1,h=y0
 call resplot
;    Plot(127-x0+y1, 127-x1,cc)
 ld a,127:sub l:add a,b:ld e,a;c=x1,l=x0,b=y1,h=y0
 ld a,127:sub c:ld d,a
 call resplot
;    Plot(127+x1-y0, 127-y1,cc)
 ld a,127:sub h:add a,c:ld e,a;c=x1,l=x0,b=y1,h=y0
 ld a,127:sub b:ld d,a
 call resplot
;    Plot(127-x1+y0, 127-y1,cc)
 ld a,127:sub c:add a,h:ld e,a
 ld a,127:sub b:ld d,a
; call resplot
; ret
resplot:
 ld a,d:sub 32:ld d,a

 call resplot2
 ld a,192:sub d:ld d,a

resplot2:
 push de
 exx
 pop de;D=Y.X
 ld h,lutpl/256
 ld l,d;Y and bank
 ld a,(hl)
 or a:jr z,nextp1
 inc h
 LD	BC,Page3
 OUT (C),A
 ld h,(hl)
 ld l,x0,d,0
 add hl,de
 ld (hl),0
nextp1:
 exx
 RET

GenP:
aX:ld hl,22175;aX=(aX+bX)!bX
;; ld (L8262+$0B-2),hl
bX:ld de,63751
; add hl,de
 call addxorhlde;xorhlde
; ld a,h:xor d:ld h,a
; ld a,l:xor e:ld l,a
 ld (aX+1),hl

aY:ld hl,17791;aY=(aY+bY)!bY
bY:ld de,63791
; add hl,de
 call addxorhlde;xorhlde
; ld a,h:xor d:ld h,a
; ld a,l:xor e:ld l,a
 ld (aY+1),hl

period equ 20;-10
cntP:ld a,period;cntP=cntP-1
 dec a:jr nz,cntPz;If cntP=0

 ld hl,(bX+1);bX=(bX+cX)!cX
cX:ld de,3
; add hl,de
 call addxorhlde;xorhlde
; ld a,h:xor d:ld h,a
; ld a,l:xor e:ld l,a
 ld (bX+1),hl

 ld hl,(bY+1);bY=(bY+cY)!cY
cY:ld de,3
; add hl,de
  call addxorhlde;xorhlde
; ld a,h:xor d:ld h,a
; ld a,l:xor e:ld l,a
 ld (bY+1),hl

 ld a,period;cntP=period
cntPz:ld (cntP+1),a

 ld a,(aX+1+1):inc a;x.a=aX+1
; or a:rra
 or a:rra:ld c,a;  x1.a=x>>1;; RSH 1
 or a:rra:ld l,a;  x0.a=x1>>1; RSH 1

 ld a,(aY+1+1):inc a;y.a=aY+1

 or a:rra:ld b,a;  y1.a=y>>1; RSH 1
 or a:rra:ld h,a;  y0.a=y1>>1; RSH 1

;If x0<=y0
 cp l;x0(L)=y0(A or H)
 jr z,doplot
  ret c; or nc?
doplot

;Plot(127+x0+y0, 127+x1-y1,RGB(255,255,255))
 ld a,127:add a,l:add a,h:ld e,a;E=X
 ld a,127:add a,c:sub b:ld d,a;D=Y
 call plot
;    Plot(127-x0-y0, 127+x1-y1,RGB(255,255,255))
 ld a,127:sub l:sub h:ld e,a
 ld a,127::add a,c:sub b:ld d,a
 call plot
;    Plot(127+x0-y1, 127-x1,RGB(255,255,255))
 ld a,127:add a,l:sub b:ld e,a
 ld a,127:sub c:ld d,a
 call plot
;    Plot(127-x0+y1, 127-x1,RGB(255,255,255))
 ld a,127:sub l:add a,b:ld e,a
 ld a,127:sub c:ld d,a
 call plot
;    Plot(127+x1-y0, 127-y1,RGB(255,255,255))
 ld a,127:sub h:add a,c:ld e,a
 ld a,127:sub b:ld d,a
 call plot
;    Plot(127-x1+y0, 127-y1,RGB(255,255,255))
 ld a,127:sub c:add a,h:ld e,a
 ld a,127:sub b:ld d,a
; call plot
; ret
plot:
 ld a,d:sub 32:ld d,a
 call plot2
 ld a,192:sub d:ld d,a
plot2:
 push de
 exx
 pop de;D=Y.X
 ld h,lutpl/256
 ld l,d;Y and bank
 ld a,(hl)
 or a:jr z,nextp
 inc h
 LD	BC,Page3
 OUT (C),A
 ld h,(hl)
 ld l,x0,d,0
 add hl,de
colr:ld (hl),0
nextp:
 exx
 RET
addxorhlde
 add hl,de
xorhlde
 ld a,h:xor d:ld h,a
 ld a,l:xor e:ld l,a
 ret

;----------------------------------------------------
plasm_pal_b:

 dw 0,$1E,$3C0,$7840,$4FC0,$3D5,$7816,$341E,$79A0,$3CB,$19E,$780C,$2FC0,$181E,$7900,$3C5,$FE,$7B00,$7808,$31E,$1BC0,$5C1E,$641E,$7805,$2DE,$73C0
 dw $7E,$3D3,$541E,$7AC0,$3DD,$29E,$FC0,$7814,$7803,$3D2,$6FC0,$47C0,$501E,$7AA0,$3DC,$7BC0,$3DE,$C1E,$781D,$6BC0,$3D1,$4C1E,$7A80,$27E,$7813
 dw $3DB,$781E,$2C1E,$3C3,$67C0,$781C,$3CF,$3FC0,$481E,$23E,$7A40,$7BA0,$7812,$3BE,$3DA,$3C9,$781B,$63C0,$401E,$19E,$7980,$7811,$741E,$78C0
 dw $7B80,$39E,$3D9,$2BC0,$3C2,$81E,$281E,$5FC0,$3CF,$17E,$781A,$780B,$7960,$7A20,$7810,$3BC0,$21E,$BC0,$701E,$5E,$3C8,$3D8,$37E,$27C0,$DE
 dw $7B60,$3CE,$241E,$15E,$5BC0,$7960,$3BC0,$1FE,$780F,$7A00,$3C1E,$780B,$7819,$78A0,$7C0,$6C1E,$141E,$41E,$17C0,$3D7,$3C7,$23C0,$35E,$BE,$7B40
 dw $37C0,$3CC,$201E,$381E,$7940,$13E,$780A,$7818,$1DE,$7807,$79E0,$57C0,$780D,$7880,$3C1,$3E,$77C0,$3C4,$13C0,$101E,$9E,$3C6,$1C1E,$601E,$681E
 dw $3D6,$7B20,$1FC0,$7806,$581E,$7804,$301E,$33E,$11E,$441E,$3CC,$53C0,$2BE,$43C0,$78E0,$2FE,$7809,$7920,$3CA,$33C0,$7AE0,$4BC0,$3D4,$25E,$3D0
 dw $37C0,$3CC,$201E,$381E,$7940,$13E,$780A,$7818,$1DE,$7807,$79E0,$57C0,$780D,$7880,$3C1,$3E,$77C0,$3C4,$13C0,$101E,$9E,$3C6,$1C1E,$601E,$681E
 dw $3D6,$7B20,$1FC0,$7806,$581E,$7804,$301E,$33E,$11E,$441E,$3CC,$53C0,$2BE,$43C0,$78E0,$2FE,$7809,$7920,$3CA,$33C0,$7AE0,$4BC0,$3D4,$25E,$3D0
 
; dw 1024*0+32*0+0;R.G.B-0
; dw 1024*1+32*31+0;R.G.B-1
; dw 1024*0+32*1+0;R.G.B-2
; dw 1024*0+32*0+31;R.G.B-3
plasm_pal_e:

end
	display /d,end-begin
	savebin "cld.bin",begin,end-begin

	LUA

	local fp = assert(io.open("cld.ini", "wb"))

	fp:write(";Description of a build - up to 32 chars\r\n")
	fp:write("Desc = Caleidoscope\r\n")

	fp:write(";Start address\r\n")
	fp:write("Start = #6000\r\n")

	fp:write(";SP adddress\r\n")
	fp:write("Stack = 24575\r\n")

	fp:write(";Resident address (16 bytes long)\r\n")
	fp:write("Resident = #5B00\r\n")
	
	fp:write(";Page at #C000 when started\r\n")
	fp:write("Page3 = 0\r\n")

	fp:write("; CPU clock: 0 - 3,5MHz / 1 - 7MHz / 2 - 14MHz / 3 - 14+MHz\r\n")
	fp:write("Clock = 1\r\n")

	fp:write("; INT: 0 - DI / 1 - EI\r\n")
	fp:write("INT = 0\r\n")

	fp:write(";Pager address (0 - not used)\r\n")
	fp:write("Pager = 0\r\n")

	fp:write("; Blocks description: address (512 multiple, #C000-#FE00), page number, filename\r\n")
	fp:write("Block = #E000,5,cld.bin\r\n")
	assert(fp:close())
	ENDLUA

